Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision c36f73bd317dd55d7e70275a6425faa4be7bfd8c)
+++ protocols/yahoo/libyahoo2.c	(revision 9034ba002b8945aee0f905b928bb0f60da9afe9f)
@@ -4913,19 +4489,21 @@
 void yahoo_send_picture_checksum(int id, const char *who, int checksum)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
 	char checksum_str[10];
 
-	if ( !yid )
+	if (!yid)
 		return;
 
 	yd = yid->yd;
-	
+
 	snprintf(checksum_str, sizeof(checksum_str), "%d", checksum);
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE_CHECKSUM, YAHOO_STATUS_AVAILABLE, 0);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE_CHECKSUM,
+		YPACKET_STATUS_DEFAULT, 0);
 	yahoo_packet_hash(pkt, 1, yd->user);
-	if ( who != 0 )
+	if (who != 0)
 		yahoo_packet_hash(pkt, 5, who);
 	yahoo_packet_hash(pkt, 192, checksum_str);
@@ -4938,5 +4516,6 @@
 void yahoo_webcam_close_feed(int id, const char *who)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_webcam_user(id, who);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_webcam_user(id, who);
 
 	if (yid)
@@ -4946,8 +4525,9 @@
 void yahoo_webcam_get_feed(int id, const char *who)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt;
-		
+
 	if (!yid)
 		return;
@@ -4960,9 +4540,10 @@
 	 * The queue is popped in yahoo_process_webcam_key
 	 */
-	webcam_queue = y_list_append(webcam_queue, who?strdup(who):NULL);
+	webcam_queue = y_list_append(webcam_queue, who ? strdup(who) : NULL);
 
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_WEBCAM, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_WEBCAM, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 
 	yahoo_packet_hash(pkt, 1, yd->user);
@@ -4974,7 +4555,9 @@
 }
 
-void yahoo_webcam_send_image(int id, unsigned char *image, unsigned int length, unsigned int timestamp)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_WEBCAM);
+void yahoo_webcam_send_image(int id, unsigned char *image, unsigned int length,
+	unsigned int timestamp)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_WEBCAM);
 	unsigned char *packet;
 	unsigned char header_len = 13;
@@ -4988,8 +4571,8 @@
 	packet[pos++] = header_len;
 	packet[pos++] = 0;
-	packet[pos++] = 5; /* version byte?? */
+	packet[pos++] = 5;	/* version byte?? */
 	packet[pos++] = 0;
 	pos += yahoo_put32(packet + pos, length);
-	packet[pos++] = 2; /* packet type, image */
+	packet[pos++] = 2;	/* packet type, image */
 	pos += yahoo_put32(packet + pos, timestamp);
 	yahoo_add_to_send_queue(yid, packet, header_len);
@@ -5000,7 +4583,8 @@
 }
 
-void yahoo_webcam_accept_viewer(int id, const char* who, int accept)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_WEBCAM);
+void yahoo_webcam_accept_viewer(int id, const char *who, int accept)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_WEBCAM);
 	char *packet = NULL;
 	char *data = NULL;
@@ -5013,5 +4597,5 @@
 
 	data = strdup("u=");
-	data = y_string_append(data, (char*)who);
+	data = y_string_append(data, (char *)who);
 	data = y_string_append(data, "\r\n");
 	len = strlen(data);
@@ -5020,8 +4604,8 @@
 	packet[pos++] = header_len;
 	packet[pos++] = 0;
-	packet[pos++] = 5; /* version byte?? */
+	packet[pos++] = 5;	/* version byte?? */
 	packet[pos++] = 0;
 	pos += yahoo_put32(packet + pos, len);
-	packet[pos++] = 0; /* packet type */
+	packet[pos++] = 0;	/* packet type */
 	pos += yahoo_put32(packet + pos, accept);
 	memcpy(packet + pos, data, len);
@@ -5033,11 +4617,13 @@
 void yahoo_webcam_invite(int id, const char *who)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_packet *pkt;
-		
+
 	if (!yid)
 		return;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_NOTIFY, YAHOO_STATUS_NOTIFY, yid->yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_NOTIFY, YPACKET_STATUS_NOTIFY,
+		yid->yd->session_id);
 
 	yahoo_packet_hash(pkt, 49, "WEBCAMINVITE");
@@ -5051,5 +4637,6 @@
 }
 
-static void yahoo_search_internal(int id, int t, const char *text, int g, int ar, int photo, int yahoo_only, int startpos, int total)
+static void yahoo_search_internal(int id, int t, const char *text, int g,
+	int ar, int photo, int yahoo_only, int startpos, int total)
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
@@ -5067,9 +4654,10 @@
 
 	/*
-	age range
-	.ar=1 - 13-18, 2 - 18-25, 3 - 25-35, 4 - 35-50, 5 - 50-70, 6 - 70+
-	*/
-
-	snprintf(buff, sizeof(buff), "&.sq=%%20&.tt=%d&.ss=%d", total, startpos);
+	   age range
+	   .ar=1 - 13-18, 2 - 18-25, 3 - 25-35, 4 - 35-50, 5 - 50-70, 6 - 70+
+	 */
+
+	snprintf(buff, sizeof(buff), "&.sq=%%20&.tt=%d&.ss=%d", total,
+		startpos);
 
 	ctext = strdup(text);
@@ -5077,7 +4665,8 @@
 		*p = '+';
 
-	snprintf(url, 1024, "http://members.yahoo.com/interests?.oc=m&.kw=%s&.sb=%d&.g=%d&.ar=0%s%s%s",
-			ctext, t, g, photo ? "&.p=y" : "", yahoo_only ? "&.pg=y" : "",
-			startpos ? buff : "");
+	snprintf(url, 1024,
+		"http://members.yahoo.com/interests?.oc=m&.kw=%s&.sb=%d&.g=%d&.ar=0%s%s%s",
+		ctext, t, g, photo ? "&.p=y" : "", yahoo_only ? "&.pg=y" : "",
+		startpos ? buff : "");
 
 	FREE(ctext);
@@ -5086,11 +4675,14 @@
 
 	inputs = y_list_prepend(inputs, yid);
-	yahoo_http_get(yid->yd->client_id, url, buff, _yahoo_http_connected, yid);
-}
-
-void yahoo_search(int id, enum yahoo_search_type t, const char *text, enum yahoo_search_gender g, enum yahoo_search_agerange ar, 
-		int photo, int yahoo_only)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	yahoo_http_get(yid->yd->client_id, url, buff, 0, 0,
+		_yahoo_http_connected, yid);
+}
+
+void yahoo_search(int id, enum yahoo_search_type t, const char *text,
+	enum yahoo_search_gender g, enum yahoo_search_agerange ar, int photo,
+	int yahoo_only)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_search_state *yss;
 
@@ -5116,5 +4708,6 @@
 void yahoo_search_again(int id, int start)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_search_state *yss;
 
@@ -5127,27 +4720,128 @@
 		start = yss->lsearch_nstart + yss->lsearch_nfound;
 
-	yahoo_search_internal(id, yss->lsearch_type, yss->lsearch_text, 
-			yss->lsearch_gender, yss->lsearch_agerange, 
-			yss->lsearch_photo, yss->lsearch_yahoo_only, 
-			start, yss->lsearch_ntotal);
-}
+	yahoo_search_internal(id, yss->lsearch_type, yss->lsearch_text,
+		yss->lsearch_gender, yss->lsearch_agerange,
+		yss->lsearch_photo, yss->lsearch_yahoo_only,
+		start, yss->lsearch_ntotal);
+}
+
+void yahoo_send_picture(int id, const char *name, unsigned long size,
+	yahoo_get_fd_callback callback, void *data)
+{
+	/* Not Implemented */
+}
+
+/* File Transfer */
+static YList *active_file_transfers = NULL;
+
+enum {
+	FT_STATE_HEAD = 1,
+	FT_STATE_RECV,
+	FT_STATE_RECV_START,
+	FT_STATE_SEND
+};
 
 struct send_file_data {
-	struct yahoo_packet *pkt;
+	int client_id;
+	char *id;
+	char *who;
+	char *filename;
+	char *ip_addr;
+	char *token;
+	int size;
+
+	struct yahoo_input_data *yid;
+	int state;
+
 	yahoo_get_fd_callback callback;
-	void *user_data;
+	void *data;
 };
 
-static void _yahoo_send_picture_connected(int id, int fd, int error, void *data)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_FT);
+static char *yahoo_get_random(void)
+{
+	int i = 0;
+	int r = 0;
+	int c = 0;
+	char out[25];
+
+	out[24] = '\0';
+	out[23] = '$';
+	out[22] = '$';
+	
+	for (i = 0; i < 22; i++) {
+		if(r == 0)
+			r = rand();
+
+		c = r%61;
+
+		if(c<26)
+			out[i] = c + 'a';
+		else if (c<52)
+			out[i] = c - 26 + 'A';
+		else
+			out[i] = c - 52 + '0';
+
+		r /= 61;
+	}
+
+	return strdup(out);
+}
+
+static int _are_same_id(const void *sfd1, const void *id)
+{
+	return strcmp(((struct send_file_data *)sfd1)->id, (char *)id);
+}
+
+static int _are_same_yid(const void *sfd1, const void *yid)
+{
+	if(((struct send_file_data *)sfd1)->yid == yid)
+		return 0;
+	else
+		return 1;
+}
+
+static struct send_file_data *yahoo_get_active_transfer(char *id)
+{
+	YList *l = y_list_find_custom(active_file_transfers, id,
+		_are_same_id);
+
+	if(l)
+		return (struct send_file_data *)l->data;
+	
+	return NULL;
+}
+
+static struct send_file_data *yahoo_get_active_transfer_with_yid(void *yid)
+{
+	YList *l = y_list_find_custom(active_file_transfers, yid,
+		_are_same_yid);
+
+	if(l)
+		return (struct send_file_data *)l->data;
+	
+	return NULL;
+}
+
+static void yahoo_add_active_transfer(struct send_file_data *sfd)
+{
+	active_file_transfers = y_list_prepend(active_file_transfers, sfd);
+}
+
+static void yahoo_remove_active_transfer(struct send_file_data *sfd)
+{
+	active_file_transfers = y_list_remove(active_file_transfers, sfd);
+	free(sfd->id);
+	free(sfd->who);
+	free(sfd->filename);
+	free(sfd->ip_addr);
+	FREE(sfd);
+}
+
+static void _yahoo_ft_upload_connected(int id, void *fd, int error, void *data)
+{
 	struct send_file_data *sfd = data;
-	struct yahoo_packet *pkt = sfd->pkt;
-	unsigned char buff[1024];
-
-	if (fd <= 0) {
-		sfd->callback(id, fd, error, sfd->user_data);
-		FREE(sfd);
-		yahoo_packet_free(pkt);
+	struct yahoo_input_data *yid = sfd->yid;
+
+	if (!fd) {
 		inputs = y_list_remove(inputs, yid);
 		FREE(yid);
@@ -5155,171 +4849,513 @@
 	}
 
+	sfd->callback(id, fd, error, sfd->data);
+
 	yid->fd = fd;
-	yahoo_send_packet(yid, pkt, 8);
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id, fd,
+		YAHOO_INPUT_READ, yid);
+}
+
+static void yahoo_file_transfer_upload(struct yahoo_data *yd,
+	struct send_file_data *sfd)
+{
+	char url[256];
+	char buff[4096];
+	char *sender_enc = NULL, *recv_enc = NULL, *token_enc = NULL;
+
+	struct yahoo_input_data *yid = y_new0(struct yahoo_input_data, 1);
+
+	yid->yd = yd;
+	yid->type = YAHOO_CONNECTION_FT;
+
+	inputs = y_list_prepend(inputs, yid);
+	sfd->yid = yid;
+	sfd->state = FT_STATE_SEND;
+
+	token_enc = yahoo_urlencode(sfd->token);
+	sender_enc = yahoo_urlencode(yd->user);
+	recv_enc = yahoo_urlencode(sfd->who);
+
+	snprintf(url, sizeof(url), 
+		"http://%s/relay?token=%s&sender=%s&recver=%s", sfd->ip_addr,
+		token_enc, sender_enc, recv_enc);
+
+	snprintf(buff, sizeof(buff), "T=%s; Y=%s", yd->cookie_t, yd->cookie_y);
+
+	yahoo_http_post(yd->client_id, url, buff, sfd->size,
+		_yahoo_ft_upload_connected, sfd);
+
+	FREE(token_enc);
+	FREE(sender_enc);
+	FREE(recv_enc);
+}
+
+static void yahoo_init_ft_recv(struct yahoo_data *yd,
+	struct send_file_data *sfd)
+{
+	char url[256];
+	char buff[1024];
+	char *sender_enc = NULL, *recv_enc = NULL, *token_enc = NULL;
+
+	struct yahoo_input_data *yid = y_new0(struct yahoo_input_data, 1);
+
+	yid->yd = yd;
+	yid->type = YAHOO_CONNECTION_FT;
+
+	inputs = y_list_prepend(inputs, yid);
+	sfd->yid = yid;
+	sfd->state = FT_STATE_HEAD;
+
+	token_enc = yahoo_urlencode(sfd->token);
+	sender_enc = yahoo_urlencode(sfd->who);
+	recv_enc = yahoo_urlencode(yd->user);
+
+	snprintf(url, sizeof(url), 
+		"http://%s/relay?token=%s&sender=%s&recver=%s", sfd->ip_addr,
+		token_enc, sender_enc, recv_enc);
+
+	snprintf(buff, sizeof(buff), "Y=%s; T=%s", yd->cookie_y, yd->cookie_t);
+
+	yahoo_http_head(yid->yd->client_id, url, buff, 0, NULL,
+		_yahoo_http_connected, yid);
+
+	FREE(token_enc);
+	FREE(sender_enc);
+	FREE(recv_enc);
+}
+
+static void yahoo_file_transfer_accept(struct yahoo_input_data *yid,
+	struct send_file_data *sfd)
+{
+	struct yahoo_packet *pkt;
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_FILETRANSFERACCEPT,
+		YPACKET_STATUS_DEFAULT, yid->yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, yid->yd->user);
+	yahoo_packet_hash(pkt, 5, sfd->who);
+	yahoo_packet_hash(pkt, 265, sfd->id);
+	yahoo_packet_hash(pkt, 27, sfd->filename);
+	yahoo_packet_hash(pkt, 249, "3");
+	yahoo_packet_hash(pkt, 251, sfd->token);
+
+	yahoo_send_packet(yid, pkt, 0);
+
 	yahoo_packet_free(pkt);
 
-	snprintf((char *)buff, sizeof(buff), "29");
-	buff[2] = 0xc0;
-	buff[3] = 0x80;
-	
-	write(yid->fd, buff, 4);
-
-	/*	YAHOO_CALLBACK(ext_yahoo_add_handler) (nyd->fd, YAHOO_INPUT_READ); */
-
-	sfd->callback(id, fd, error, sfd->user_data);
-	FREE(sfd);
-	inputs = y_list_remove(inputs, yid);
-	/*
-	while (yahoo_tcp_readline(buff, sizeof(buff), nyd->fd) > 0) {
-	if (!strcmp(buff, ""))
-	break;
-}
-
-	*/
-	yahoo_input_close(yid);
-}
-
-void yahoo_send_picture(int id, const char *name, unsigned long size,
-							yahoo_get_fd_callback callback, void *data)
-{
-	struct yahoo_data *yd = find_conn_by_id(id);
+	yahoo_init_ft_recv(yid->yd, sfd);
+}
+
+static void yahoo_process_filetransferaccept(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	YList *l;
+	struct send_file_data *sfd;
+	char *who = NULL;
+	char *filename = NULL;
+	char *id = NULL;
+	char *token = NULL;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		switch (pair->key) {
+		case 4:
+			who = pair->value;
+			break;
+		case 5:
+			/* Me... don't care */
+			break;
+		case 249:
+			break;
+		case 265:
+			id = pair->value;
+			break;
+		case 251:
+			token = pair->value;
+			break;
+		case 27:
+			filename = pair->value;
+			break;
+		}
+	}
+
+	sfd = yahoo_get_active_transfer(id);
+
+	if (sfd) {
+		sfd->token = strdup(token);
+
+		yahoo_file_transfer_upload(yid->yd, sfd);
+	}
+	else {
+		YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+			(yid->yd->client_id, YAHOO_FILE_TRANSFER_UNKNOWN,
+			sfd->data);
+
+		yahoo_remove_active_transfer(sfd);
+	}
+}
+
+static void yahoo_process_filetransferinfo(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	YList *l;
+	char *who = NULL;
+	char *filename = NULL;
+	char *id = NULL;
+	char *token = NULL;
+	char *ip_addr = NULL;
+
+	struct send_file_data *sfd;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		switch (pair->key) {
+		case 1:
+		case 4:
+			who = pair->value;
+			break;
+		case 5:
+			/* Me... don't care */
+			break;
+		case 249:
+			break;
+		case 265:
+			id = pair->value;
+			break;
+		case 250:
+			ip_addr = pair->value;
+			break;
+		case 251:
+			token = pair->value;
+			break;
+		case 27:
+			filename = pair->value;
+			break;
+		}
+	}
+
+	sfd = yahoo_get_active_transfer(id);
+
+	if (sfd) {
+		sfd->token = strdup(token);
+		sfd->ip_addr = strdup(ip_addr);
+
+		yahoo_file_transfer_accept(yid, sfd);
+	}
+	else {
+		YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+			(yid->yd->client_id, YAHOO_FILE_TRANSFER_UNKNOWN,
+			sfd->data);
+
+		yahoo_remove_active_transfer(sfd);
+	}
+}
+
+static void yahoo_send_filetransferinfo(struct yahoo_data *yd,
+	struct send_file_data *sfd)
+{
 	struct yahoo_input_data *yid;
-	struct yahoo_server_settings *yss;
+	struct yahoo_packet *pkt;
+
+	yid = find_input_by_id_and_type(yd->client_id, YAHOO_CONNECTION_PAGER);
+	sfd->ip_addr = YAHOO_CALLBACK(ext_yahoo_get_ip_addr)("relay.yahoo.com");
+
+	if (!sfd->ip_addr) {
+		YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+			(yd->client_id, YAHOO_FILE_TRANSFER_RELAY, sfd->data);
+
+		yahoo_remove_active_transfer(sfd);
+
+		return;
+	}
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_FILETRANSFERINFO,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
+
+	yahoo_packet_hash(pkt, 1, yd->user);
+	yahoo_packet_hash(pkt, 5, sfd->who);
+	yahoo_packet_hash(pkt, 265, sfd->id);
+	yahoo_packet_hash(pkt, 27, sfd->filename);
+	yahoo_packet_hash(pkt, 249, "3");
+	yahoo_packet_hash(pkt, 250, sfd->ip_addr);
+
+	yahoo_send_packet(yid, pkt, 0);
+
+	yahoo_packet_free(pkt);
+}
+
+static void yahoo_process_filetransfer(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	YList *l;
+	char *who = NULL;
+	char *filename = NULL;
+	char *msg = NULL;
+	char *id = NULL;
+	int action = 0;
+	int size = 0;
+	struct yahoo_data *yd = yid->yd;
+
+	struct send_file_data *sfd;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		switch (pair->key) {
+		case 4:
+			who = pair->value;
+			break;
+		case 5:
+			/* Me... don't care */
+			break;
+		case 222:
+			action = atoi(pair->value);
+			break;
+		case 265:
+			id = pair->value;
+			break;
+		case 266: /* Don't know */
+			break;
+		case 302: /* Start Data? */
+			break;
+		case 300:
+			break;
+		case 27:
+			filename = pair->value;
+			break;
+		case 28:
+			size = atoi(pair->value);
+			break;
+		case 14:
+			msg = pair->value;
+		case 301: /* End Data? */
+			break;
+		case 303:
+			break;
+
+		}
+	}
+
+	if (action == YAHOO_FILE_TRANSFER_INIT) {
+		/* Received a FT request from buddy */
+		sfd = y_new0(struct send_file_data, 1);
+        
+		sfd->client_id = yd->client_id;
+		sfd->id = strdup(id);
+		sfd->who = strdup(who);
+		sfd->filename = strdup(filename);
+		sfd->size = size;
+        
+		yahoo_add_active_transfer(sfd);
+
+		YAHOO_CALLBACK(ext_yahoo_got_file) (yd->client_id, yd->user,
+			who, msg, filename, size, sfd->id);
+	}
+	else {
+		/* Response to our request */
+		sfd = yahoo_get_active_transfer(id);
+
+		if (sfd && action == YAHOO_FILE_TRANSFER_ACCEPT) {
+			yahoo_send_filetransferinfo(yd, sfd);
+		}
+		else if (!sfd || action == YAHOO_FILE_TRANSFER_REJECT) {
+			YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+				(yd->client_id, YAHOO_FILE_TRANSFER_REJECT,
+				sfd->data);
+
+			yahoo_remove_active_transfer(sfd);
+		}
+	}
+}
+
+void yahoo_send_file(int id, const char *who, const char *msg,
+	const char *name, unsigned long size,
+	yahoo_get_fd_callback callback, void *data)
+{
 	struct yahoo_packet *pkt = NULL;
 	char size_str[10];
-	char expire_str[10];
-	long content_length = 0;
-	unsigned char buff[1024];
-	char url[255];
+	struct yahoo_input_data *yid;
+	struct yahoo_data *yd;
 	struct send_file_data *sfd;
+	
+	yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	yd = find_conn_by_id(id);
+	sfd = y_new0(struct send_file_data, 1);
+
+	sfd->client_id = id;
+	sfd->id = yahoo_get_random();
+	sfd->who = strdup(who);
+	sfd->filename = strdup(name);
+	sfd->size = size;
+	sfd->callback = callback;
+	sfd->data = data;
+
+	yahoo_add_active_transfer(sfd);
 
 	if (!yd)
 		return;
 
-	yss = yd->server_settings;
-
-	yid = y_new0(struct yahoo_input_data, 1);
-	yid->yd = yd;
-	yid->type = YAHOO_CONNECTION_FT;
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_PICTURE_UPLOAD, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_FILETRANSFER,
+		YPACKET_STATUS_DEFAULT, yd->session_id);
 
 	snprintf(size_str, sizeof(size_str), "%ld", size);
-	snprintf(expire_str, sizeof(expire_str), "%ld", (long)604800);
-
-	yahoo_packet_hash(pkt, 0, yd->user);
+
 	yahoo_packet_hash(pkt, 1, yd->user);
-	yahoo_packet_hash(pkt, 14, "");
+	yahoo_packet_hash(pkt, 5, who);
+	yahoo_packet_hash(pkt, 265, sfd->id);
+	yahoo_packet_hash(pkt, 222, "1");
+	yahoo_packet_hash(pkt, 266, "1");
+	yahoo_packet_hash(pkt, 302, "268");
+	yahoo_packet_hash(pkt, 300, "268");
 	yahoo_packet_hash(pkt, 27, name);
 	yahoo_packet_hash(pkt, 28, size_str);
-	yahoo_packet_hash(pkt, 38, expire_str);
+	yahoo_packet_hash(pkt, 301, "268");
+	yahoo_packet_hash(pkt, 303, "268");
+
+	yahoo_send_packet(yid, pkt, 0);
+
+	yahoo_packet_free(pkt);
+}
+
+void yahoo_send_file_transfer_response(int client_id, int response, char *id, void *data)
+{
+	struct yahoo_packet *pkt = NULL;
+	char resp[2];
+	struct yahoo_input_data *yid;
 	
-
-	content_length = YAHOO_PACKET_HDRLEN + yahoo_packet_length(pkt);
-
-	snprintf(url, sizeof(url), "http://%s:%d/notifyft",
-				yss->filetransfer_host, yss->filetransfer_port);
-	snprintf((char *)buff, sizeof(buff), "Y=%s; T=%s",
-				 yd->cookie_y, yd->cookie_t);
-	inputs = y_list_prepend(inputs, yid);
-
-	sfd = y_new0(struct send_file_data, 1);
-	sfd->pkt = pkt;
-	sfd->callback = callback;
-	sfd->user_data = data;
-	yahoo_http_post(yid->yd->client_id, url, (char *)buff, content_length+4+size,
-						_yahoo_send_picture_connected, sfd);
-}
-
-static void _yahoo_send_file_connected(int id, int fd, int error, void *data)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_FT);
-	struct send_file_data *sfd = data;
-	struct yahoo_packet *pkt = sfd->pkt;
-	unsigned char buff[1024];
-
-	if (fd <= 0) {
-		sfd->callback(id, fd, error, sfd->user_data);
-		FREE(sfd);
-		yahoo_packet_free(pkt);
-		inputs = y_list_remove(inputs, yid);
-		FREE(yid);
-		return;
-	}
-
-	yid->fd = fd;
-	yahoo_send_packet(yid, pkt, 8);
+	struct send_file_data *sfd = yahoo_get_active_transfer(id);
+
+	sfd->data = data;
+
+	yid = find_input_by_id_and_type(client_id, YAHOO_CONNECTION_PAGER);
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_Y7_FILETRANSFER,
+		YPACKET_STATUS_DEFAULT, yid->yd->session_id);
+
+	snprintf(resp, sizeof(resp), "%d", response);
+
+	yahoo_packet_hash(pkt, 1, yid->yd->user);
+	yahoo_packet_hash(pkt, 5, sfd->who);
+	yahoo_packet_hash(pkt, 265, sfd->id);
+	yahoo_packet_hash(pkt, 222, resp);
+
+	yahoo_send_packet(yid, pkt, 0);
+
 	yahoo_packet_free(pkt);
 
-	snprintf((char *)buff, sizeof(buff), "29");
-	buff[2] = 0xc0;
-	buff[3] = 0x80;
+	if(response == YAHOO_FILE_TRANSFER_REJECT)
+		yahoo_remove_active_transfer(sfd);
+}
+
+static void yahoo_process_ft_connection(struct yahoo_input_data *yid, int over)
+{
+	struct send_file_data *sfd;
+	struct yahoo_data *yd = yid->yd;
 	
-	write(yid->fd, buff, 4);
-
-/*	YAHOO_CALLBACK(ext_yahoo_add_handler) (nyd->fd, YAHOO_INPUT_READ); */
-
-	sfd->callback(id, fd, error, sfd->user_data);
-	FREE(sfd);
-	inputs = y_list_remove(inputs, yid);
-	/*
-	while (yahoo_tcp_readline(buff, sizeof(buff), nyd->fd) > 0) {
-		if (!strcmp(buff, ""))
-			break;
-	}
-
-	*/
-	yahoo_input_close(yid);
-}
-
-void yahoo_send_file(int id, const char *who, const char *msg, 
-		const char *name, unsigned long size, 
-		yahoo_get_fd_callback callback, void *data)
-{
-	struct yahoo_data *yd = find_conn_by_id(id);
-	struct yahoo_input_data *yid;
-	struct yahoo_server_settings *yss;
-	struct yahoo_packet *pkt = NULL;
-	char size_str[10];
-	long content_length = 0;
-	unsigned char buff[1024];
-	char url[255];
-	struct send_file_data *sfd;
-
-	if (!yd)
-		return;
-
-	yss = yd->server_settings;
-
-	yid = y_new0(struct yahoo_input_data, 1);
-	yid->yd = yd;
-	yid->type = YAHOO_CONNECTION_FT;
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_FILETRANSFER, YAHOO_STATUS_AVAILABLE, yd->session_id);
-
-	snprintf(size_str, sizeof(size_str), "%ld", size);
-
-	yahoo_packet_hash(pkt, 0, yd->user);
-	yahoo_packet_hash(pkt, 5, who);
-	yahoo_packet_hash(pkt, 14, msg);
-	yahoo_packet_hash(pkt, 27, name);
-	yahoo_packet_hash(pkt, 28, size_str);
-
-	content_length = YAHOO_PACKET_HDRLEN + yahoo_packet_length(pkt);
-
-	snprintf(url, sizeof(url), "http://%s:%d/notifyft", 
-			yss->filetransfer_host, yss->filetransfer_port);
-	snprintf((char *)buff, sizeof(buff), "Y=%s; T=%s",
-			yd->cookie_y, yd->cookie_t);
-	inputs = y_list_prepend(inputs, yid);
-
-	sfd = y_new0(struct send_file_data, 1);
-	sfd->pkt = pkt;
-	sfd->callback = callback;
-	sfd->user_data = data;
-	yahoo_http_post(yid->yd->client_id, url, (char *)buff, content_length+4+size,
-			_yahoo_send_file_connected, sfd);
-}
-
+	sfd = yahoo_get_active_transfer_with_yid(yid);
+
+	if (!sfd) {
+		LOG(("Something funny happened. yid %p has no sfd.\n", yid));
+		return;
+	}
+
+	/* 
+	 * We want to handle only the complete data with HEAD since we don't
+	 * want a situation where both the GET and HEAD are active.
+	 * With SEND, we really can't do much with partial response
+	 */
+	if ((sfd->state == FT_STATE_HEAD || sfd->state == FT_STATE_SEND) 
+			&& !over)
+		return;
+
+	if (sfd->state == FT_STATE_HEAD) {
+		/* Do a GET */
+		char url[256];
+		char buff[1024];
+		char *sender_enc = NULL, *recv_enc = NULL, *token_enc = NULL;
+
+		struct yahoo_input_data *yid_ft = 
+			y_new0(struct yahoo_input_data, 1);
+        
+		yid_ft->yd = yid->yd;
+		yid_ft->type = YAHOO_CONNECTION_FT;
+        
+		inputs = y_list_prepend(inputs, yid_ft);
+		sfd->yid = yid_ft;
+		sfd->state = FT_STATE_RECV;
+
+		token_enc = yahoo_urlencode(sfd->token);
+		sender_enc = yahoo_urlencode(sfd->who);
+		recv_enc = yahoo_urlencode(yd->user);
+        
+		snprintf(url, sizeof(url), 
+			"http://%s/relay?token=%s&sender=%s&recver=%s", sfd->ip_addr,
+			token_enc, sender_enc, recv_enc);
+
+		snprintf(buff, sizeof(buff), "Y=%s; T=%s", yd->cookie_y,
+			yd->cookie_t);
+
+
+		yahoo_http_get(yd->client_id, url, buff, 1, 1,
+			_yahoo_http_connected, yid_ft);
+
+		FREE(token_enc);
+		FREE(sender_enc);
+		FREE(recv_enc);
+	}
+	else if (sfd->state == FT_STATE_RECV || 
+		sfd->state == FT_STATE_RECV_START) {
+
+		unsigned char *data_begin = NULL;
+
+		if (yid->rxlen == 0)
+			yahoo_remove_active_transfer(sfd);
+
+		if (sfd->state != FT_STATE_RECV_START &&
+			(data_begin = 
+				(unsigned char *)strstr((char *)yid->rxqueue,
+				"\r\n\r\n"))) {
+
+			sfd->state = FT_STATE_RECV_START;
+
+			yid->rxlen -= 4+(data_begin-yid->rxqueue)/sizeof(char);
+			data_begin += 4;
+
+			if (yid->rxlen > 0)
+				YAHOO_CALLBACK(ext_yahoo_got_ft_data) 
+					(yd->client_id, data_begin,
+					yid->rxlen, sfd->data);
+		}
+		else if (sfd->state == FT_STATE_RECV_START)
+			YAHOO_CALLBACK(ext_yahoo_got_ft_data) (yd->client_id,
+				yid->rxqueue, yid->rxlen, sfd->data);
+
+		FREE(yid->rxqueue);
+		yid->rxqueue = NULL;
+		yid->rxlen = 0;
+	}
+	else if (sfd->state == FT_STATE_SEND) {
+		/* Sent file completed */
+		int len = 0;
+		char *off = strstr((char *)yid->rxqueue, "Content-Length: ");
+
+		if (off) {
+			off += 16;
+			len = atoi(off);
+		}
+
+		if (len < sfd->size)
+			YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+				(yd->client_id,
+				YAHOO_FILE_TRANSFER_FAILED, sfd->data);
+		else
+			YAHOO_CALLBACK(ext_yahoo_file_transfer_done)
+				(yd->client_id,
+				YAHOO_FILE_TRANSFER_DONE, sfd->data);
+
+		yahoo_remove_active_transfer(sfd);
+	}
+}
+
+/* End File Transfer */
 
 enum yahoo_status yahoo_current_status(int id)
@@ -5362,4 +5398,6 @@
 	if (!strncasecmp(which, "y", 1))
 		return yd->cookie_y;
+	if (!strncasecmp(which, "b", 1))
+		return yd->cookie_b;
 	if (!strncasecmp(which, "t", 1))
 		return yd->cookie_t;
@@ -5371,17 +5409,6 @@
 }
 
-void yahoo_get_url_handle(int id, const char *url, 
-		yahoo_get_url_handle_callback callback, void *data)
-{
-	struct yahoo_data *yd = find_conn_by_id(id);
-	if (!yd)
-		return;
-
-	yahoo_get_url_fd(id, url, yd, callback, data);
-}
-
-const char *yahoo_get_profile_url( void )
+const char *yahoo_get_profile_url(void)
 {
 	return profile_url;
 }
-
